From 8c911650e5909464113e1ad9eb468c9f6c3cb555 Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 1/32] Issues: Initial commit


---

diff --git a/hubs/default_config.py b/hubs/default_config.py
index 546342a..3d2b33d 100644
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -73,5 +73,6 @@ WIDGETS = [
     'hubs.widgets.pagureissues:PagureIssues',
     'hubs.widgets.repositories:Repositories',
     'hubs.widgets.sticky:Sticky',
+    'hubs.widgets.issues:Issues',
     'hubs.widgets.workflow.updates2stable:Updates2Stable',
     ]
diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
new file mode 100644
index 0000000..616df54
--- /dev/null
+++ b/hubs/widgets/issues/__init__.py
@@ -0,0 +1,102 @@
+from __future__ import unicode_literals
+
+from hubs.widgets import validators
+from hubs.widgets.base import Widget
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.view import RootWidgetView
+
+import requests
+
+
+class Issues(Widget):
+
+    name = "issues"
+    label = "Issues"
+    position = "left"
+    parameters = [
+        dict(
+            name="github_username",
+            label="Github Username",
+            default="None",
+            validator=validators.Text,
+            help="Github username to show issues of",
+        ),
+        dict(
+            name="pagure_username",
+            label="Pagure Username",
+            default="None",
+            validator=validators.Text,
+            help="Pagure username to show issues of",
+        ),
+        dict(
+            name="bugzilla_username",
+            label="Bugzilla Username",
+            default="None",
+            validator=validators.Text,
+            help="Bugzilla username to show issues of",
+        )
+    ]
+
+
+class BaseView(RootWidgetView):
+
+    def get_context(self, instance, *args, **kwargs):
+        bugzilla_bugs = GetBugzillaBugs(instance)
+        github_issues = GetGithubIssues(instance)
+        pagure_issues = GetPagureIssues(instance)
+        return dict(
+            bugzilla_bugs=bugzilla_bugs(),
+            github_issues=github_issues(),
+            pagure_issues=pagure_issues()
+        )
+
+
+class GetBugzillaBugs(CachedFunction):
+
+    def execute(self):
+        username = self.instance.config["bugzilla_username"]
+        endpoint = "https://bugzilla.redhat.com/jsonrpc.cgi?method=Bug.search&params=[{{\"creator\":\"{}\"}}]"
+        response = requests.get(endpoint.format(username)).json()
+        issues = response['result']['bugs']
+        issues = issues[:min(5, len(issues))]
+        return issues
+
+    def should_invalidate(self, message):
+        return False
+
+    def _should_cache(self, value):
+        return False
+
+
+class GetPagureIssues(CachedFunction):
+
+    def execute(self):
+        username = self.instance.config["pagure_username"]
+        endpoint = "https://pagure.io/api/0/user/{}/issues"
+        response = requests.get(endpoint.format(username)).json()
+        issues = response['issues_created']
+        issues = issues[:min(5, len(issues))]
+        return issues
+
+    def should_invalidate(self, message):
+        return False
+
+    def _should_cache(self, value):
+        return False
+
+
+class GetGithubIssues(CachedFunction):
+
+    def execute(self):
+        username = self.instance.config["github_username"]
+        endpoint = "https://api.github.com/search/issues?q=is:issue+author:{}&sort:updated"
+        response = requests.get(endpoint.format(username)).json()
+        issues = response['items']
+        issues = issues[:min(5, len(issues))]
+        return issues
+
+    def should_invalidate(self, message):
+        return False
+
+    def _should_cache(self, value):
+        return False
